//------------------------------------------------------------------------
// File and Version Information: DrcDtag.hh
// 
// temporary definition of DIRC dtag structure
//------------------------------------------------------------------------

#ifndef DRCDTAG_HH
#define DRCDTAG_HH

#include "DrcTagMap.hh"

const int  _NMOD(12);    // should get all this somewhere
const int  _NCHAN(16);   //
const int  _NCHIP(4);    //
const int  _NSECT(14);   //
const int  _IDET(0);     //
const unsigned int _chanMask(0xff);  // idem...
const unsigned int _chipMask(0x1f);  //
const unsigned int _sectMask(0x1f);  //
const unsigned int _moduMask(0xff);  //
const unsigned int _dttrMask(0x1f);  //
const int _chanShft(0);              // 
const int _chipShft(8);              //
const int _sectShft(13);             //
const int _moduShft(18);             //
const int _dttrShft(26);             //


//main class
class DrcDtag : public DrcTagMap {

 public:
  //constructors
  DrcDtag(int doCheckCIndex, int doCheckSIndex);   

  //hash functions
  int CShashFunc(int cindex);   //go from sparse to compact
  //go from compact to sparse using a cache
  inline int FastCShashFunc(int cindex){ return _CShashTable[cindex]; }

  int SChashFunc(int cindex);  //go from compact to sparse

  
  //check functions
  int CheckSIndex(int sindex) const;
  int CheckCIndex(int cindex) const;
  
 private:
  //cache
  int *_CShashTable;  //compact to sparse hash table
  int _cindexMax;   //max compact index value

};

#endif
