//------------------------------------------------------------------------
// File and Version Information:
//      $Id: ??? $
//
// Description:
//      Class DrcTagMap. Service class implementing the relations
//      between various tag maps (dtag,gtag, ptag?)
//      
// Environment:
//      Software developed for the BaBar Detector at the SLAC B-Factory.
//
// Author List:
//      ???              
//
// Copyright Information:
//      Copyright (C) 1997      Lawrence Berkeley Laboratory
//
//------------------------------------------------------------------------

#include "DrcTagMap.hh"

//
//constructors
//

//null
DrcTagMap::DrcTagMap(){;}
  
//main constructor
DrcTagMap::DrcTagMap(int doCheckCIndex, int doCheckSIndex)  
 : _doCheckCIndex(doCheckCIndex),
   _doCheckSIndex(doCheckSIndex)
{;}
  
//copy constructor
DrcTagMap::DrcTagMap( const DrcTagMap& ){;}

//destructor
 DrcTagMap::~DrcTagMap(){
  if(_CShashTable != 0) delete [] _CShashTable;
 }

//mapping functions
int DrcTagMap::csmap(int cindex){      //compact to sparse mapping
 int index_status=1;
  if(_doCheckCIndex!=0) index_status=CheckCIndex(cindex);   
  if(index_status) return FastCShashFunc(cindex);
  else return -1;
}

int DrcTagMap::scmap(int sindex){      //sparse to compact mapping
 int index_status=1;
  if(_doCheckSIndex!=0) index_status=CheckSIndex(sindex);
  if(index_status) return SChashFunc(sindex);
  else return -1;
}

