      PROGRAM MAPPING

      PARAMETER (Nx=29,Ny=40)
      DIMENSION NumHT(0:Nx,0:Ny),NumHarness(0:Nx,0:Ny)
      DIMENSION NumChan(0:Nx,0:Ny)

      PARAMETER (NHarness=13,NHT=55,NChan=63,NChanar=8)
      DIMENSION NlistHarness(0:NHarness),NListHT(0:NHT)
      DIMENSION NListChan1(0:NHarness),ListHT(NHT+1)
      DIMENSION NListChan2(0:NChan),iChanar1(NChanar),iChanar2(NChanar)

      LOGICAL AUTTEST /.TRUE./ !...perform automatic tests

      LOGICAL ERROR /.FALSE./ !...must always be set to .FALSE.

      LOGICAL TEST,NOTEST
      DATA TEST,NOTEST /.TRUE.,.FALSE./

      COMMON /TYPECOM/ NumHT,NumHarness,NumChan
C
C init arrays: "NumHT,NumHarness,NumChan" contain the HT cable, 
C              harness number and channel number corresponding
C              to the line/hole (x,y) PM position
C
C    NOTE:  (x, y) coordinates corespond to (hole number, line number)
C
      CALL InitConversion( )
C
C automatic test
C
      IF (AUTTEST) THEN
         WRITE(*,*)
         WRITE(*,*)' --------- Do automatic test -----------'
         WRITE(*,*)
C
C...innit first
         DO iHarness=0,NHarness
            NListHarness(iHarness) = 0
            NListChan1(iHarness)  = 0
         ENDDO
         DO iHT=0,NHT
            NListHT(iHT) = 0
         ENDDO
         DO iChan=0,NChan
            NListChan2(iChan) = 0
         ENDDO
C
C...sum over all positions
         DO ix=0,Nx
            DO iy=0,Ny

               IF (NumHarness(ix,iy).ge.0        .AND.
     >             NumHarness(ix,iy).le.NHarness .AND.
     >             NumHT(ix,iy).ge.0             .AND. 
     >             NumHT(ix,iy).le.NHT           .AND.
     >             NumChan(ix,iy).ge.0           .AND. 
     >             NumChan(ix,iy).le.NChan) THEN

                  NListHarness(NumHarness(ix,iy)) = 
     >                 NListHarness(NumHarness(ix,iy)) + 1
                  NListHT(NumHT(ix,iy))     = 
     >                 NListHT(NumHT(ix,iy)) + 1
                  NListChan1(NumHarness(ix,iy))  = 
     >                 NListChan1(NumHarness(ix,iy)) + NumChan(ix,iy)
                  NListChan2(NumChan(ix,iy))    = 
     >                 NListChan2(NumChan(ix,iy)) + 1
               ELSEIF( NumHarness(ix,iy).ne.-1 .OR.  
     >                 NumHT(ix,iy).ne.-1      .OR.
     >                 NumChan(ix,iy).ne.-1 ) THEN
                  WRITE(*,*)' WARNING: Problems in (x,y) coordinates:'
                  WRITE(*,*)' -->  NumHarness(',ix,iy,') =',
     >                      NumHarness(ix,iy)
                  WRITE(*,*)' -->  NumHT  (',ix,iy,') =',
     >                      NumHT(ix,iy)
                  WRITE(*,*)' -->  NumChan  (',ix,iy,') =',
     >                      NumChan(ix,iy)
                  WRITE(*,*)
               ENDIF

            ENDDO
         ENDDO
C
C...check if results are correct         
         WRITE(*,*)' ... test: HT cables cross only two lines'
         DO iHT=0,NHT
            CALL GetHarness( iHT,iHarness1,iHarness2,
     >                           iChanar1,iChanar2,TEST )
         ENDDO
         WRITE(*,*)
         WRITE(*,*)' ... test: NListHarness'
         DO iHarness=0,NHarness
            IF (NListHarness(iHarness).ne.64) THEN
               WRITE(*,*)' NListHarness(',iHarness,') =',
     >                   NListHarness(iHarness)
               ERROR = .TRUE.
            ENDIF
         ENDDO
         WRITE(*,*)
         WRITE(*,*)' ... test: NListHT'
         DO iHT=0,NHT
            IF (NListHT(iHT).ne.16) THEN
               WRITE(*,*)' NListHT(',iHT,') =',NListHT(iHT)
               ERROR = .TRUE.
            ENDIF
         ENDDO
         i1 = 0
         i2 = 63
         NSum = NGetSum( i1,i2 )
         WRITE(*,*)
         WRITE(*,*)' ... test: NListChan1'
         DO iHarness=0,NHarness
            IF (NListChan1(iHarness).ne.NSum) THEN
               WRITE(*,*)' NListChan1(',iHarness,') =',
     >                   NListChan1(iHarness),' / NSum =',NSum
               ERROR = .TRUE.
            ENDIF                         
         ENDDO
         WRITE(*,*)
         WRITE(*,*)' ... test: NListChan2'
         DO iChan=0,NChan
            IF (NListChan2(iChan).ne.14) THEN
               WRITE(*,*)' NListChan2(',iChan,') =',NListChan2(iChan)
               ERROR = .TRUE.
            ENDIF               
         ENDDO
         WRITE(*,*)
         IF (ERROR) THEN
            WRITE(*,*)' .... automatic test terminated:',
     >                ' ERROR(S) OCURRED... stop program'
         STOP
         ELSE
            WRITE(*,*)' .... automatic test successfully terminated.'
         ENDIF
         WRITE(*,*)' ---------------------------------------'
      ENDIF
C
C manual test
C
 150  WRITE(*,*)
      WRITE(*,*)' <1> - input: (hole, line number) of PM',
     >          ' / output: HT cable'
      WRITE(*,*)' <2> - input: (hole, line number) of PM',
     >          ' / output: harness and channel'
      WRITE(*,*)' <3> - input: Harness and channel (PM) ',
     >          ' / output: (hole, line number)'
      WRITE(*,*)' <4> - input: Harness and channel (PM) ',
     >          ' / output: HT cable'
      WRITE(*,*)' <5> - input: HT cable                 ',
     >          ' / output: Powered channels'
      WRITE(*,*)' <6> - input: Harnesses (first-last)   ',
     >          ' / output: HT cables'
      WRITE(*,*)
      WRITE(*,*)' <0> - Quit program'
      WRITE(*,*)
      WRITE(*,*)' Make your choice, please: '
      READ*, iChoice
      IF (iChoice.lt.1 .OR. iChoice.gt.6) THEN
         WRITE(*,*)' --> this choice is not valid! Try again...'
         GOTO 150
      ENDIF
      IF (iChoice.eq.0) THEN
         WRITE(*,*)
         WRITE(*,*)' ... end of program.'
         STOP
      ENDIF

      IF (iChoice.le.2) THEN
         WRITE(*,*)' --> Give (hole-, line number) of channel (PM):'
         READ*, ix,iy
         IF (ix.gt.Nx .OR. iy.gt.Ny .OR. ix.lt.0 .OR. iy.lt.0) THEN
            WRITE(*,*)' ++++ bad choice of coordinates ++++'
            GOTO 150
         ENDIF
         IF (iChoice.eq.1) 
     >     WRITE(*,*)'     ---> corresponding HT cable:',NumHT(ix,iy)
         IF (iChoice.eq.2) 
     >     WRITE(*,*)'     ---> corresponding harness and channel (PM)',
     >               ' number:',NumHarness(ix,iy),NumChan(ix,iy)
      ELSEIF (iChoice.eq.3) THEN
         WRITE(*,*)' --> Give harness and channel (PM) number: '
         READ*, iHarness,iChan
         CALL GetPosxy( iHarness,iChan,ix,iy )
         WRITE(*,*)'     ---> corresponding (hole number, line number)',
     >             ':',ix,iy
      ELSEIF (iChoice.eq.4) THEN
         WRITE(*,*)' --> Give harness and channel (PM) number: '
         READ*, iHarness,iChan
         WRITE(*,*)'     ---> corresponding HT cable:',
     >      NGetCableHT( iHarness,iChan )
      ELSEIF (iChoice.eq.5) THEN
         WRITE(*,*)' --> Give HT cable: '
         READ*, iHT
         CALL GetHarness( iHT,iHarness1,iHarness2,
     >                        iChanar1,iChanar2,,NOTEST )
         WRITE(*,*)'     ---> corresponding harnesses (channels):'
         WRITE(*,*)'     ...Harness-1 =',iHarness1,' / Channels: (',
     >              iChanar1(1),' -',iChanar1(8),' )'
         WRITE(*,*)'     ...Harness-2 =',iHarness2,' / Channels: (',
     >              iChanar2(1),' -',iChanar2(8),' )'
      ELSEIF (iChoice.eq.6) THEN
         WRITE(*,*)' --> Give harnesses (first and last)'
         READ*, iHarness1, iHarness2
         CALL NGetAllCableHT( iHarness1,iHarness2,ListHT,iHT )
 190     FORMAT( '      ---> corresponding HT cables:',70(1x,I2) )
         WRITE(*,190) (ListHT(jHT),jHT=NHT-iHT+2,NHT+1)
      ENDIF
      WRITE(*,*)'     ============================================',
     >          '========'

      WRITE(*,*)
      WRITE(*,*)'------------------------------------------------------'
      GOTO 150

      END
C
C * --------------------- F U N C T I O N S ------------------------------- *
C
      SUBROUTINE InitConversion( )

      CALL InitHT( )
      CALL InitHarness( )
      CALL InitChan( )

      RETURN
      END
C
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C      
      SUBROUTINE InitHT( )

      PARAMETER (Nx=29,Ny=40)
      DIMENSION NumHT(0:Nx,0:Ny),NumHarness(0:Nx,0:Ny)
      DIMENSION NumChan(0:Nx,0:Ny)
      COMMON /TYPECOM/ NumHT,NumHarness,NumChan
C
C fill cables of High Tension (HT)
C
      DATA NumHT(0:Nx,0:20) /
C
     >   05,04,04,03,03,02,02,01,01,01,00,00,-1,-1,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,04,04,03,03,02,02,02,01,01,01,00,00,-1,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,04,04,04,03,03,02,02,01,01,01,00,00,00,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,04,04,03,03,02,02,02,01,01,01,00,00,-1,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,04,04,04,03,03,02,02,01,01,01,00,00,00,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,05,04,04,03,03,02,02,08,07,07,01,06,00,00,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,10,09,09,04,03,03,02,08,07,07,07,06,06,00,
     >   00,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,10,09,04,03,03,02,08,08,07,07,07,06,06,06,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,10,09,09,09,12,12,08,08,07,07,07,06,06,06,
     >   11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,05,10,09,09,12,12,08,08,08,07,07,07,06,06,
     >   06,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,05,10,10,09,09,12,12,08,08,14,07,07,13,06,
     >   06,11,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   05,05,10,09,09,12,12,08,15,15,14,14,14,13,06,
     >   06,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   10,10,10,16,09,12,12,08,08,15,14,14,14,13,13,
     >   13,13,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   10,10,17,16,09,12,12,08,08,15,15,14,14,14,13,
     >   13,13,11,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   10,10,17,17,16,09,12,12,15,15,15,14,14,14,14,
     >   13,13,13,11,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   10,10,17,16,09,12,12,15,15,15,15,20,14,14,19,
     >   13,13,18,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   17,17,17,16,16,22,22,22,15,15,21,21,20,20,20,
     >   19,13,13,18,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   17,17,17,16,16,16,22,22,15,15,21,21,20,20,20,
     >   19,19,19,18,18,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   17,17,17,17,16,16,22,22,22,21,21,21,21,20,20,
     >   20,19,19,19,18,11,11,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   17,17,23,16,16,22,22,22,21,21,21,21,20,20,20,
     >   19,19,19,18,18,11,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   23,23,23,25,16,16,22,22,22,21,21,24,24,20,20,
     >   20,19,19,19,18,18,18,-1,-1,-1,-1,-1,-1,-1,-1
     >      /

      DATA NumHT(0:Nx,21:Ny) /
C
     >   23,23,23,25,25,16,22,22,29,24,21,21,24,28,28,
     >   28,27,27,19,26,26,18,18,-1,-1,-1,-1,-1,-1,-1,
C
     >   23,23,23,23,25,25,29,29,29,29,24,24,24,24,28,
     >   28,28,27,27,19,26,26,18,18,-1,-1,-1,-1,-1,-1,
C
     >   23,23,23,25,25,25,29,29,29,29,24,24,24,28,28,
     >   28,27,27,27,26,26,18,18,-1,-1,-1,-1,-1,-1,-1,
C
     >   30,30,23,25,25,25,29,29,29,29,24,24,24,24,28,
     >   28,28,27,27,27,26,26,26,26,-1,-1,-1,-1,-1,-1,
C
     >   30,30,30,23,25,25,25,29,29,33,29,32,24,32,28,
     >   28,28,27,27,27,31,31,26,26,26,-1,-1,-1,-1,-1,
C
     >   30,30,30,30,36,25,25,33,33,33,33,32,32,32,32,
     >   35,35,28,34,27,27,31,31,26,26,26,-1,-1,-1,-1,
C
     >   30,30,30,36,36,36,36,33,33,33,33,32,32,32,35,
     >   35,35,34,34,27,31,31,31,31,31,-1,-1,-1,-1,-1,
C
     >   37,37,30,30,36,36,36,33,33,33,33,33,32,32,32,
     >   35,35,35,34,34,34,31,31,31,31,31,-1,-1,-1,-1,
C
     >   37,37,30,30,36,36,36,36,33,33,39,39,32,32,32,
     >   35,35,35,34,34,34,38,38,38,38,31,31,-1,-1,-1,
C
     >   37,37,37,36,36,36,36,39,39,39,39,39,40,40,32,
     >   35,35,35,34,34,34,38,38,38,38,38,-1,-1,-1,-1,
C
     >   37,37,37,37,43,43,43,43,39,39,39,39,40,40,40,
     >   42,35,35,41,34,34,34,38,38,38,38,38,-1,-1,-1,
C
     >   45,45,37,37,43,43,43,43,39,39,39,39,39,40,40,
     >   40,42,42,42,41,41,34,44,38,38,44,44,44,-1,-1,
C
     >   45,37,37,43,43,43,43,43,46,46,46,46,40,40,40,
     >   42,42,42,41,41,41,41,44,44,44,44,44,-1,-1,-1,
C
     >   45,45,45,37,43,47,47,43,43,46,46,46,46,40,40,
     >   40,42,42,42,41,41,41,44,44,44,44,44,44,-1,-1,
C
     >   45,45,45,45,47,47,47,47,47,46,46,46,46,50,40,
     >   40,42,42,42,41,41,41,41,48,48,44,48,48,48,-1,
C
     >   45,45,45,45,47,47,47,47,47,46,46,46,46,50,50,
     >   50,42,42,42,49,41,49,41,48,48,48,48,48,-1,-1,
C
     >   54,54,45,45,53,47,47,47,47,52,52,52,52,50,50,
     >   50,51,51,51,51,49,49,49,48,48,48,48,48,48,-1,
C
     >   54,54,54,54,54,53,53,53,53,53,52,52,52,52,50,
     >   50,50,51,51,51,51,49,49,49,55,55,55,55,55,55,
C
     >   54,54,54,54,53,53,53,53,53,52,52,52,52,50,50,
     >   50,51,51,51,51,49,49,49,49,55,55,55,55,55,-1,
C
     >   54,54,54,54,54,53,53,53,53,53,52,52,52,52,50,
     >   50,50,51,51,51,51,49,49,49,49,55,55,55,55,55   
     >         /

      RETURN
      END

      SUBROUTINE InitHarness( )

      PARAMETER (Nx=29,Ny=40)
      DIMENSION NumHT(0:Nx,0:Ny),NumHarness(0:Nx,0:Ny)
      DIMENSION NumChan(0:Nx,0:Ny)
      COMMON /TYPECOM/ NumHT,NumHarness,NumChan
C
C fill Harness number
C
      DATA NumHarness(0:Nx,0:20) /
C
     >   01,02,03,04,05,06,07,08,08,09,10,10,-1,-1,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   01,02,03,04,05,06,07,07,08,09,09,10,11,-1,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   01,02,02,03,04,05,06,07,08,08,09,10,10,11,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   01,02,03,04,05,06,07,07,08,09,09,10,11,-1,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   01,02,02,03,04,05,06,07,08,08,09,10,10,11,-1,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   01,01,02,03,04,05,06,07,07,08,09,09,10,11,11,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   01,01,02,02,03,04,05,06,07,08,08,09,10,10,11,
     >   11,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,01,02,03,04,05,06,07,07,08,09,09,10,11,11,
     >   -1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,01,02,02,03,04,05,06,07,08,08,09,10,10,11,
     >   12,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,04,05,06,07,07,08,09,09,10,11,
     >   11,12,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,01,02,03,04,05,06,07,08,08,09,10,10,
     >   11,12,12,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,04,05,06,07,07,08,09,09,10,11,
     >   11,12,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,04,05,06,06,07,08,08,09,10,10,  
     >   11,11,12,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,04,05,06,06,07,07,08,09,09,10,
     >   10,11,12,13,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,01,02,03,04,05,06,06,07,08,08,09,09,
     >   10,11,11,12,13,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,04,05,06,06,07,07,08,08,09,10,
     >   10,11,12,13,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,04,05,05,06,06,07,07,08,09,09,
     >   10,11,11,12,13,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,03,04,05,06,06,07,07,08,08,09,
     >   10,10,11,12,12,13,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,01,02,03,04,05,05,06,06,07,07,08,09,  
     >   09,10,11,11,12,13,13,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,04,04,05,06,06,07,07,08,08,09,
     >   10,10,11,12,12,13,-1,-1,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,03,04,05,05,06,06,07,07,08,09,
     >   09,10,11,11,12,13,13,-1,-1,-1,-1,-1,-1,-1,-1
     >      /

      DATA NumHarness(0:Nx,21:Ny) /
C
     >   00,00,01,02,02,03,04,04,05,06,06,06,07,08,08,
     >   09,10,10,11,12,12,13,13,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,01,02,03,04,04,05,05,06,06,07,07,08,
     >   09,09,10,11,11,12,12,13,13,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,03,03,04,04,05,05,06,06,07,08,08,
     >   09,10,10,11,12,12,13,13,-1,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,02,02,03,04,04,05,05,06,06,07,07,08,
     >   09,09,10,11,11,12,12,13,13,-1,-1,-1,-1,-1,-1,
C
     >   00,00,01,01,02,03,03,04,04,05,05,06,06,07,08,
     >   08,09,10,10,11,12,12,13,13,13,-1,-1,-1,-1,-1,
C
     >   00,00,01,01,02,03,03,04,04,05,05,06,06,07,07,  
     >   08,09,09,10,11,11,12,12,13,13,13,-1,-1,-1,-1,
C
     >   00,00,01,02,02,03,03,04,04,05,05,06,06,07,08,   
     >   08,09,10,10,11,12,12,13,13,13,-1,-1,-1,-1,-1,
C
     >   00,00,01,01,02,03,03,04,04,05,05,05,06,07,07,
     >   08,09,09,10,11,11,12,12,13,13,13,-1,-1,-1,-1,
C
     >   00,00,01,01,02,02,03,03,04,04,05,05,06,06,07,
     >   08,08,09,10,10,11,12,12,13,13,13,13,-1,-1,-1,
C
     >   00,00,01,02,02,03,03,04,04,04,05,05,06,07,07,
     >   08,09,09,10,11,11,12,12,13,13,13,-1,-1,-1,-1,
C
     >   00,00,01,01,02,02,03,03,04,04,05,05,06,06,07,
     >   08,08,09,10,10,11,11,12,12,13,13,13,-1,-1,-1,
C
     >   00,00,01,01,02,02,03,03,04,04,04,05,05,06,07,
     >   07,08,09,09,10,11,11,12,12,12,13,13,13,-1,-1,
C
     >   00,01,01,02,02,02,03,03,04,04,05,05,06,06,07,  
     >   08,08,09,10,10,11,11,12,12,12,13,13,-1,-1,-1,
C
     >   00,00,01,01,02,02,03,03,03,04,04,05,05,06,07,
     >   07,08,09,09,10,11,11,12,12,12,13,13,13,-1,-1,
C
     >   00,00,01,01,02,02,02,03,03,04,04,05,05,06,06,
     >   07,08,08,09,10,10,11,11,12,12,12,13,13,13,-1,
C
     >   00,01,01,01,02,02,03,03,03,04,04,05,05,06,07,
     >   07,08,09,09,10,10,11,11,12,12,12,13,13,-1,-1,
C
     >   00,00,01,01,02,02,02,03,03,04,04,05,05,06,06,
     >   07,08,08,09,09,10,10,11,12,12,12,13,13,13,-1,
C
     >   00,00,01,01,01,02,02,03,03,03,04,04,05,05,06,
     >   07,07,08,08,09,09,10,11,11,12,12,12,13,13,13,
C
     >   00,00,01,01,02,02,02,03,03,04,04,05,05,06,06,  
     >   07,08,08,09,09,10,10,11,11,12,12,12,13,13,-1,
C
     >   00,00,01,01,01,02,02,03,03,03,04,04,05,05,06,
     >   07,07,08,08,09,09,10,10,11,11,12,12,13,13,13   
     >         /

      RETURN
      END

      SUBROUTINE InitChan( )

      PARAMETER (Nx=29,Ny=40)
      DIMENSION NumHT(0:Nx,0:Ny),NumHarness(0:Nx,0:Ny)
      DIMENSION NumChan(0:Nx,0:Ny)
      COMMON /TYPECOM/ NumHT,NumHarness,NumChan

      PARAMETER (NHarness=13)
      DIMENSION NListHarness(0:NHarness)
C
C fill number of Chan in Harness
C
C...init first
      DO iHarness=0,NHarness
         NListHarness(iHarness) = -1
      ENDDO

      DO iy=0,Ny
         DO ix=0,Nx
            IF (NumHarness(ix,iy).ne.-1) THEN
               NListHarness(NumHarness(ix,iy)) = 
     >              NListHarness(NumHarness(ix,iy)) + 1
               NumChan(ix,iy) = NListHarness(NumHarness(ix,iy))
            ELSE
               NumChan(ix,iy) = -1
            ENDIF
         ENDDO
      ENDDO
C
C...correct for exceptions
      NumChan(10,05) = 08
      NumChan(11,05) = 07

      NumChan(10,10) = 16
      NumChan(11,10) = 15
      NumChan(13,10) = 16
      NumChan(14,10) = 15

      NumChan(11,15) = 24
      NumChan(12,15) = 23
      NumChan(14,15) = 24
      NumChan(15,15) = 23

      NumChan(09,21) = 32
      NumChan(10,21) = 30
      NumChan(11,21) = 31

      NumChan(18,22) = 32
      NumChan(19,22) = 31

      NumChan(02,25) = 32
      NumChan(03,25) = 31
      NumChan(09,25) = 32
      NumChan(10,25) = 31
      NumChan(11,25) = 40
      NumChan(12,25) = 39

      NumChan(16,26) = 40
      NumChan(17,26) = 39

      NumChan(23,29) = 32
      NumChan(24,29) = 33
      NumChan(25,29) = 30
      NumChan(26,29) = 31

      NumChan(13,30) = 48
      NumChan(14,30) = 47

      NumChan(15,31) = 48
      NumChan(16,31) = 47
      NumChan(18,31) = 48
      NumChan(19,31) = 47

      NumChan(20,32) = 48
      NumChan(21,32) = 47
      NumChan(22,32) = 40
      NumChan(23,32) = 38
      NumChan(24,32) = 39

      NumChan(02,34) = 48
      NumChan(03,34) = 47
      NumChan(06,34) = 48
      NumChan(07,34) = 46
      NumChan(08,34) = 47

      NumChan(13,35) = 56
      NumChan(14,35) = 55
      NumChan(23,35) = 48
      NumChan(24,35) = 49
      NumChan(25,35) = 47

      NumChan(19,36) = 56
      NumChan(20,36) = 55
      NumChan(21,36) = 56
      NumChan(22,36) = 55

      NumChan(04,37) = 56
      NumChan(05,37) = 54
      NumChan(06,37) = 55

      RETURN
      END
C
C --------------------------------------------------------------------
C
      FUNCTION NGetCableHT( iHarness,iChan )
C
C Input:  iHarness - number of line (harness)
C         iChan    - number of Chan (PM) in line
C
C Output: NGetCableHT - Number of corresponding high tension cable
C
      PARAMETER (NHarness=13,NChan=63)
      PARAMETER (Nx=29,Ny=40)
      DIMENSION NumHT(0:Nx,0:Ny),NumHarness(0:Nx,0:Ny)
      DIMENSION NumChan(0:Nx,0:Ny)

      COMMON /TYPECOM/ NumHT,NumHarness,NumChan
C
C...first check:
      NGetCableHT = -1
      IF (iHarness.gt.NHarness .OR. iChan.gt.NChan .OR.
     >    iHarness.lt.0     .OR. iChan.lt.0) THEN
         WRITE(*,*)' WARNING: in "NGetCableHT" Harness/Channel',
     >             ' out of range',iHarness,iChan
         RETURN
      ENDIF
C
C...search to fit conditions
      DO ix=0,Nx
         DO iy=0,Ny
            IF (NumHarness(ix,iy).eq.iHarness .AND. 
     >          NumChan(ix,iy).eq.iChan) GOTO 150
         ENDDO
      ENDDO
      WRITE(*,*)' WARNING: in "NGetCableHT" Harness/Chan',
     >          ' condition not found'
      RETURN

 150  NGetCableHT = NumHt(ix,iy)

      RETURN
      END
C
C --------------------------------------------------------------------
C
      SUBROUTINE NGetAllCableHT( iHarness1,iHarness2,ListHT,iHT )
C
C Input:  iHarness1/2 - first/last Harness
C
C Output: ListHT      - List of all HT cables needed
C
      PARAMETER (NHT=55+1,NChan=63)
      DIMENSION ListHT(NHT)
C
C...init...
      DO iHT=1,NHT
         ListHT(iHT) = -1
      ENDDO
      iHT = 0
C
C loop over harnesses and channels (PMs)
C
      DO 150 iHarness=iHarness1,iHarness2
         DO 150 iChan=0,NChan
            kHT = NGetCableHT( iHarness,iChan )
            DO jHT=1,iHT
               IF (ListHT(jHT).eq.kHT) GOTO 150
            ENDDO
            iHT = iHT + 1
            ListHT(iHT) = kHT
 150   CONTINUE
C
C...sort arrays of channels
      CALL INTSOR(ListHT,NHT)

      RETURN
      END
C
C --------------------------------------------------------------------
C
      SUBROUTINE GetHarness( iHT,iHarness1,iHarness2,
     >                           iChanar1,iChanar2,TEST )
C
C Input:  iHT - Number of high tension cable
C
C Output: iHarness1 - number of first corresponding line (harness)
C         iHarness2 - number of second corresponding line 
C
      PARAMETER (NHT=55)
      PARAMETER (Nx=29,Ny=40,NChan=63,NChanar=8)
      DIMENSION NumHT(0:Nx,0:Ny),NumHarness(0:Nx,0:Ny)
      DIMENSION NumChan(0:Nx,0:Ny)
      DIMENSION iChanar1(NChanar),iChanar2(NChanar)

      LOGICAL TEST

      COMMON /TYPECOM/ NumHT,NumHarness,NumChan
C
C...first check:
      iHarness1 = -1
      iHarness2 = -1
      DO iChan=1,NChanar
         iChanar1(iChan) = -1
         iChanar2(iChan) = -1
      ENDDO
      IF (iHT.gt.NHT .OR. iHT.lt.0) THEN
         WRITE(*,*)' WARNING: in "GetHarness" iHT out of range'
         RETURN
      ENDIF
C
C...search to fit conditions
      iChan1 = 0
      iChan2 = 0
      DO ix=0,Nx
         DO iy=0,Ny
            IF (NumHT(ix,iy).eq.iHT) THEN               
C
C...collect lines               
               IF (iHarness1.eq.-1) iHarness1 = NumHarness(ix,iy)
               IF (iHarness2.eq.-1 .AND. iHarness1.ne.NumHarness(ix,iy))
     >                           iHarness2 = NumHarness(ix,iy)
               IF (TEST                           .AND. 
     >             iHarness2.ne.-1                .AND. 
     >             iHarness1.ne.NumHarness(ix,iy) .AND.
     >             iHarness2.ne.NumHarness(ix,iy)) THEN
                  WRITE(*,*)' Problem in GetHarness: More than',
     >                      ' two lines in one cable: iHT =',iHT
               ENDIF
C
C...collect channels
               IF (NumHarness(ix,iy).eq.iHarness1) THEN
                  iChan1 = iChan1 + 1
                  IF (iChan1.le.NChanar) 
     >                 iChanar1(iChan1) = NumChan(ix,iy) 
               ELSEIF (NumHarness(ix,iy).eq.iHarness2) THEN
                  iChan2 = iChan2 + 1
                  IF (iChan2.le.NChanar) 
     >                 iChanar2(iChan2) = NumChan(ix,iy) 
               ENDIF

            ENDIF
         ENDDO
      ENDDO
      IF (iHarness1.eq.-1 .OR. iHarness2.eq.-1)
     >  WRITE(*,*)' WARNING: in "GetHarness",',iHT,
     >            ' Harness/channel not found'
      IF (iChan1.ne.NChanar .OR. iChan2.ne.NChanar) 
     >  WRITE(*,*)' WARNING: in "GetHarness",',iHT,
     >            ' Number of channels in HT group <>',2*NChanar,':',
     >            iChan1,iChan2
C
C...sort arrays of channels
      CALL INTSOR(iChanar1,NChanar)
      CALL INTSOR(iChanar2,NChanar)
      IF (iChanar1(8)-iChanar1(1).ne.7 .OR. 
     >    iChanar2(8)-iChanar2(1).ne.7)
     >  WRITE(*,*)' WARNING: in "GetHarness",',iHT,
     >            ' Channels in HT group not in incrementing order',
     >            iChanar1(8)-iChanar1(1),iChanar2(8)-iChanar2(1)

      RETURN
      END
C
C --------------------------------------------------------------------
C
      SUBROUTINE GetPosxy( iHarness,iChan,ix,iy )
C
C Input:  iHarness - number of line (harness)
C         iChan   - number of Chan in line
C
C Output: ix,iy - (x,y) position of Chan
C
      PARAMETER (NHarness=13,NChan=63)
      PARAMETER (Nx=29,Ny=40)
      DIMENSION NumHT(0:Nx,0:Ny),NumHarness(0:Nx,0:Ny)
      DIMENSION NumChan(0:Nx,0:Ny)

      COMMON /TYPECOM/ NumHT,NumHarness,NumChan
C
C...first check:
      ix = -1
      iy = -1
      IF (iHarness.gt.NHarness .OR. iChan.gt.NChan .OR.
     >    iHarness.lt.0     .OR. iChan.lt.0) THEN
         WRITE(*,*)' WARNING: in "GetPosxy" Harness/Chan out of range'
         RETURN
      ENDIF
C
C...search to fit conditions
      DO ix=0,Nx
         DO iy=0,Ny
            IF (NumHarness(ix,iy).eq.iHarness .AND. 
     >          NumChan(ix,iy).eq.iChan)             GOTO 150
         ENDDO
      ENDDO
      WRITE(*,*)' WARNING: in "GetPosxy" Harness/Channel',
     >          ' condition not found'
      RETURN

 150  CONTINUE

      RETURN
      END
C
C ----------- auxiliary functions -- auxiliary functions ----------------
C
      FUNCTION NGetSum( i1,i2 )

      NGetSum = 0
      DO i=i1,i2
         NGetSum = NGetSum + i
      ENDDO

      RETURN
      END




